<?php

require 'vendor/autoload.php';

use Aws\S3\S3Client;
use Aws\Exception\AwsException;

curl_setopt($ch, CURLOPT_BUFFERSIZE, 128000); // 128 KB buffer size

// Ativar o buffer de saída
ob_start();

// Configurações do cliente S3
$s3Client = new S3Client([
    'version' => 'latest',
    'region' => 'us-la', // Modifique conforme necessário
    'endpoint' => 'https://h4t1.la5.idrivee2-9.com', // Seu endpoint compatível com S3
    'credentials' => [
        'key'    => 'd8WYsMkB3qXqVpbuLI3M', // Access Key ID
        'secret' => 'jN9B5kFasSaqY4QqZ09sMtRXptNoGuF8gLLjywdo', // Secret Access Key
    ],
    'use_path_style_endpoint' => true, // Necessário para iDrive e serviços compatíveis com S3
]);

$bucket = 'teste-bkp';
$key = 'meuarquivo.zip';
$file = 'arquivo.zip';

try {
    // Medir o tamanho do arquivo
    $filesize = filesize($file); // Tamanho em bytes

    // Captura o tempo inicial
    $startTime = microtime(true);

    // Imprime imediatamente que o upload foi iniciado
    echo "Iniciando o upload do arquivo '{$file}'...\n";
    echo "Início do upload às: " . date('Y-m-d H:i:s', (int) $startTime) . "\n";

    // Forçar a impressão imediata para o navegador ou terminal
    ob_flush(); // Envia o conteúdo do buffer de saída
    flush();    // Limpa o buffer do PHP e força o envio imediato ao navegador/terminal

    // Envia o arquivo para o bucket
    $result = $s3Client->putObject([
        'Bucket' => $bucket,
        'Key'    => $key,
        'SourceFile' => $file,
        'ContentType' => 'application/zip',
    ]);

    // Captura o tempo final
    $endTime = microtime(true);

    // Calcula o tempo gasto em segundos
    $timeTaken = $endTime - $startTime;

    // Converte o tamanho do arquivo para megabits (1 byte = 8 bits, 1 megabit = 1.000.000 bits)
    $fileSizeInMegabits = ($filesize * 8) / 1000000;

    // Calcula a velocidade média em Mbps (megabits por segundo)
    $uploadSpeedMbps = $fileSizeInMegabits / $timeTaken;

    echo "Arquivo enviado com sucesso. URL do arquivo: " . $result['ObjectURL'] . "\n";
    echo "Velocidade média de upload: " . number_format($uploadSpeedMbps, 2) . " Mbps\n";
    echo "Inicio: {$startTime} ; Fim: {$endTime}\n";

    // Forçar a impressão final
    ob_flush();
    flush();

} catch (AwsException $e) {
    echo "Erro ao enviar arquivo: " . $e->getMessage() . "\n";

    // Forçar a impressão em caso de erro
    ob_flush();
    flush();
}

// Encerra o buffer de saída
ob_end_flush();
